# Copyright (C) 2006-2008 by Sergio Pistone
# sergio_pistone@yahoo.com.ar
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the
# Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

$LOAD_PATH << File.expand_path(File.dirname(__FILE__))

require "utils/strings"
require "lyrics"

require "cgi"

class Lyrc < Lyrics

	def Lyrc.site_host()
		return "lyrc.com.ar"
	end

	def Lyrc.site_name()
		return "Lyrc"
	end

	# TODO how to test suggestions?
	def Lyrc.lyrics_test_data()
		return [
			Request.new( "Nirvana", "Smells Like Teen Spirit", "Nevermind" ),
			Request.new( "Radiohead", "How To Disappear Completely", "Kid A" ),
			Request.new( "Pearl Jam", "Love Boat Captain", "Riot Act" ),
			Request.new( "Blur", "No Distance Left To Run", "13" ),
		]
	end

	def Lyrc.suggestions_test_data()
		return []
	end

	def Lyrc.build_song_add_url( request )
		return "http://#{site_host()}/en/add/add.php"
	end

	def build_lyrics_fetch_data( request )
		artist = Strings.utf82latin1( request.artist )
		title  = Strings.utf82latin1( request.title )
		return FetchPageData.new( "http://#{site_host()}/en/tema1en.php?artist=#{CGI.escape( artist )}&songname=#{CGI.escape( title )}" )
	end

	def parse_lyrics( response, page_body )

		page_body = Strings.latin12utf8( page_body )
		page_body.tr_s!( " \n\r\t", " " )

		md = /<font size='2' ?> ?<b>([^<]+)<\/b> ?<br> ?<u>([^<]+)<\/u> ?<\/font>(.+)<a href="#" onClick="javascript:window.open\('\/?badsong.php\?/.match( page_body )
		md = /<font size='2' ?> ?<b>([^<]+)<\/b> ?<br> ?<u><font size='2' ?>([^<]+)<\/font> ?<\/u> ?<\/font>(.+)<a href="#" onClick="javascript:window.open\('\/?badsong.php\?/.match( page_body ) if ( md == nil )

		if ( md )

			response.artist, response.title, page_body = md[2], md[1], md[3]

			page_body.gsub!( /^.*<\/script>/, "" )
			page_body.gsub!( /^.*<\/table>/, "" )
			page_body.gsub!( /<p><hr size=1 noshade color=white width=100%>.*$/, "" )
			page_body.gsub!( /\ ?<br ?\/?> ?/i, "\n" )
			page_body.gsub!( /\n{3,}/, "\n\n" )

			response.lyrics = page_body
		end

	end

	def build_suggestions_fetch_data( request )
		# Same as the lyrics url (if the lyrics are found returns the lyrics, else the suggestions are)
		return build_lyrics_fetch_data( request )
	end

	# returns an array of maps with following keys: url, artist, title
	def parse_suggestions( request, page_body )

		page_body = Strings.latin12utf8( page_body )
		page_body.tr_s!( " \n\r\t", " " )

		suggestions = []

		md = /Suggestions : <br>(.+)<br><br> If none is your song <br><br>/.match( page_body )
		return suggestions if ( md == nil )

		md[1].split( "</a>" ).each do |entry|
			if ( md = /<a href="([^"]+)"><font color='white'>([^<]+) - ([^<]+)<\/font>/.match( entry ) )
				suggestions << Suggestion.new( md[2], md[3], "http://#{site_host()}/en/#{md[1]}" )
			end
		end

		return suggestions

	end

end
